[![Build Status](https://travis-ci.org/niiknow/mooncrafts.svg?branch=master)](https://travis-ci.org/niiknow/mooncrafts)
# mooncrafts
> Network http utilities (crafts) written in moonscript 

Utilities written in moonscript that can be use independently with lua http.server, moonscript, and/or openresty.

# usage
A set of classes from [moonship](https://github.com/niiknow/moonship) for re-usability.  Originally inspired by webscript.io provided utility functions.

1. [asynclogger](https://github.com/niiknow/mooncrafts/blob/master/lib/mooncrafts/asynclogger.moon) asynchronously forward function request logs to azure table storage
2. [awsauth](https://github.com/niiknow/mooncrafts/blob/master/lib/mooncrafts/awsauth.moon) create awsv4 header/signature
3. [azauth](https://github.com/niiknow/mooncrafts/blob/master/lib/mooncrafts/azauth.moon) create azure sharedkeylite signature
4. [aztable](https://github.com/niiknow/mooncrafts/blob/master/lib/mooncrafts/aztable.moon) utilities for azure tablestorage
5. [crypto](https://github.com/niiknow/mooncrafts/blob/master/lib/mooncrafts/crypto.moon) common crypto utilities
6. [date](https://github.com/niiknow/mooncrafts/blob/master/lib/mooncrafts/date.moon) some datetime math
7. [hmacauth](https://github.com/niiknow/mooncrafts/blob/master/lib/mooncrafts/hmacauth.moon) allow for hmac auth
8. [http](https://github.com/niiknow/mooncrafts/blob/master/lib/mooncrafts/http.moon) making http request with added capability such as: auto basic auth and oauth1
9. [httpsocket](https://github.com/niiknow/mooncrafts/blob/master/lib/mooncrafts/httpsocket.moon) making http request with socket
10. [resty.http](https://github.com/niiknow/mooncrafts/blob/master/lib/mooncrafts/resty/http.moon) making http request with openresty
11. [log](https://github.com/niiknow/mooncrafts/blob/master/lib/mooncrafts/log.moon) friendly logger
12. [oauth1](https://github.com/niiknow/mooncrafts/blob/master/lib/mooncrafts/oauth1.moon) for oauth1 signature
13. [remoteresolver](https://github.com/niiknow/mooncrafts/blob/master/lib/mooncrafts/remoteresolver.moon) help resolve code stored on github repository
14. [sandbox](https://github.com/niiknow/mooncrafts/blob/master/lib/mooncrafts/sandbox.moon) best effort of attempting to restrict code to a sandbox
15. [url](https://github.com/niiknow/mooncrafts/blob/master/lib/mooncrafts/url.moon) utilities for parsing url
16. [util](https://github.com/niiknow/mooncrafts/blob/master/lib/mooncrafts/util.moon) common utilities

# build and test
osx, install lua/luarocks and openssl then:
```sh
sudo luarocks install luasec OPENSSL_DIR=/usr/local/opt/openssl
make init
make test
```

# MIT
